`timescale 1ns / 1ps

module AD7606_UART_tb();

    reg 		 Clk;
	reg 		 Reset_n;
	reg 		 key_in;
    wire        Rs232_Tx;
	
    wire        ad7606_cs_n_o;         
	wire         ad7606_rd_n_o;         
	reg        ad7606_busy_i;         
	reg [15:0] ad7606_db_i;           
	wire [2:0]  ad7606_os_o;           
	wire         ad7606_reset_o;        
	wire         ad7606_convst_o; 
	
	
	
	    /*ߣ˴ĬΪ9600bps治޸Ĳ*/	
	wire [2:0]Baud_Set;
	reg [7:0]Tx_Data;/*ڷͷģʹֽ*/
	reg Tx_En;	/*ڷͷģͷʹź*/
	wire Rs232_MTSR;	/*"PC-ӻFPGA"ź*/
	wire Tx_Done;	/*ֽڷź*/
	  
    initial Clk = 1;
    always #10 Clk = ~Clk;

    AD7606_UART AD7606_UART(
        Clk,
        Reset_n,
        key_in,
        Rs232_Tx,
        Rs232_MTSR,
        
        ad7606_cs_n_o,   
        ad7606_rd_n_o,   
        ad7606_busy_i,   
        ad7606_db_i,     
        ad7606_os_o,     
        ad7606_reset_o,  
        ad7606_convst_o
    );
    

	
    /*------ڷͷģ------*/
	Uart_Tx_Model Uart_Tx_Model(
		.Baud_Set(Baud_Set),
		.Tx_Data(Tx_Data),
		.Tx_En(Tx_En),
		.uart_tx(Rs232_MTSR),
		.Tx_Done(Tx_Done)
	);
	
    assign Baud_Set = 3'd4;/*òΪ̶9600bps*/
    
    always@(posedge ad7606_convst_o)begin
        #40;
        ad7606_busy_i = 1;
        #3960;
        ad7606_busy_i = 0;    
    end
        
    always@(negedge ad7606_rd_n_o)begin
        ad7606_db_i <= ad7606_db_i + 1;
    end
    


		
 /*---֡-----*/	
	task Send_CMD;
		input [7:0]CMD_ADDR;/*ûַ*/
		input [31:0]CMD_DATA;/*û*/
		begin
			Tx_Data = 8'h55;/*跢Ϊ֡ͷ1*/
			Tx_En = 1;	/**/
			#20 Tx_En = 0;	/*һʱں㷢ź*/
			@(posedge Tx_Done)/*ȴź*/
			#1000;

			Tx_Data = 8'hA5;/*跢Ϊ֡ͷ2*/
			Tx_En = 1;	/**/
			#20 Tx_En = 0;	/*һʱں㷢ź*/
			@(posedge Tx_Done)/*ȴź*/
			#1000;
					
			Tx_Data = CMD_ADDR;/*跢Ϊ*/
			Tx_En = 1;	/**/
			#20 Tx_En = 0;	/*һʱں㷢ź*/
			@(posedge Tx_Done)/*ȴź*/
			#1000;
			
			Tx_Data = CMD_DATA[31:24];/*跢ݵ1ֽ*/
			Tx_En = 1;	/**/
			#20 Tx_En = 0;	/*һʱں㷢ź*/
			@(posedge Tx_Done)/*ȴź*/
			#1000;
			
			Tx_Data = CMD_DATA[23:16];/*跢ݵ2ֽ*/
			Tx_En = 1;	/**/
			#20 Tx_En = 0;	/*һʱں㷢ź*/
			@(posedge Tx_Done)/*ȴź*/
			#1000;

			Tx_Data = CMD_DATA[15:8];/*跢ݵ3ֽ*/
			Tx_En = 1;	/**/
			#20 Tx_En = 0;	/*һʱں㷢ź*/
			@(posedge Tx_Done)/*ȴź*/
			#1000;
			
			Tx_Data = CMD_DATA[7:0];/*跢ݵ4ֽ*/
			Tx_En = 1;	/**/
			#20 Tx_En = 0;	/*һʱں㷢ź*/
			@(posedge Tx_Done)/*ȴź*/
			#1000;			
						
			Tx_Data = 8'hF0;/*跢Ϊ֡β*/
			Tx_En = 1;	/**/
			#20 Tx_En = 0;	/*һʱں㷢ź*/
			@(posedge Tx_Done)/*ȴź*/
			#1000;
			#10000;	
		end
	endtask	   
       
       
	
	task Set_DataNum;/*òݸ*/
	   input [31:0] DataNum;
		begin
			Send_CMD(2, DataNum);
			$display("Set Data Num as %0d",DataNum);
		end
	endtask
	
	task Set_ChannelSel;/*òͨ*/
	   input [7:0] ChannelSel;
		begin
			Send_CMD(1, {24'd0,ChannelSel});
			$display("Set Channel as %0d",ChannelSel);
		end
	endtask

	task Set_SampleSpeed;/*ò*/
	   input [31:0] SampleSpeed;
	   reg [31:0]speed;
		begin
		    speed = 1000000000/20/SampleSpeed- 1;
			Send_CMD(3, speed);
			$display("Set Sample Speed as %0d",speed);
		end
	endtask
	
	task Set_SampleGo;/*ÿʼ*/
		begin
			Send_CMD(0, 32'd1);
			$display("Start");
		end
	endtask	
	

    initial begin
        ad7606_db_i = 16'h1234;
        ad7606_busy_i = 0;  
        Reset_n = 0;
        key_in = 1;
        #201;
        Reset_n = 1;
        #200;
        
        Set_DataNum(1024);
        Set_ChannelSel(1);
        Set_SampleSpeed(100000);
        Set_SampleGo();     
    
    end	
	
//    integer i;
    
//    initial begin
//        ad7606_db_i = 16'h1234;
//        ad7606_busy_i = 0;  
//        Reset_n = 0;
//        i=0;
//        RestartReq = 0;
//        adc_data_flag = 8'b0000_0000;;
//        adc_data_mult_ch = 0;
//        #201;
//        Reset_n = 1;
//        #200;
//        RestartReq = 1;
//        #20;
//        RestartReq = 0;
//        #200;
//        repeat(120)begin
//            for(i=0;i<8;i=i+1)begin
//                adc_data_mult_ch = adc_data_mult_ch + 1;
//                adc_data_flag = 1 << i;
//                #20;
//                adc_data_flag = 0;
//                #100;
//            end
//        end   
//        #2000;
//        $stop; 
//    end
endmodule
