/*============================================================================
*
*  LOGIC CORE:          ڷͷģ	
*  MODULE NAME:         Uart_Tx_Model()
*  COMPANY:             оߵӹ
*                       http://xiaomeige.taobao.com
*	author:					С÷
*	author QQ Group472607506
*  REVISION HISTORY:  
*
*    Revision 1.0  01/01/2016     Description: Initial Release.
*
*	FileType	Testbench
*
*  FUNCTIONAL DESCRIPTION:
*
*	FileType	Testbench
*	
*  ģΪڷͷģ
*
===========================================================================*/
`timescale 1ns/1ps

module Uart_Tx_Model(Baud_Set,Tx_Data,Tx_En,uart_tx,Tx_Done);
	
	input [2:0]Baud_Set;	/*ѡź*/
	input [7:0]Tx_Data;	/*ֽ*/
	input Tx_En;			/*ֽڷʹź*/
	output reg uart_tx;	/*洮ڷģͷź*/
	output reg Tx_Done;	/*ź*/
	
	reg Clk;	/*ģڲʱ*/
	reg Rst_n;	/*ģڲλź*/
	
	wire Bps_Clk;	/*ͲʱӲ*/
	reg Bps_En;	/*Ͳʹź*/
		
	initial Clk = 1;
	always#10 Clk = ~Clk;

/*----Ͳʱģ-----*/	
	TxModel_Bps_Gen TxModel_Bps_Gen_send(
		.Clk(Clk),
		.Rst_n(Rst_n),
		.Baud_Set(Baud_Set),
		.Tx_Done(Tx_Done),
		.Bps_Clk(Bps_Clk),
		.Byte_En(Bps_En)
	);
		
	initial begin
		Tx_Done = 0;
		uart_tx = 1;
		Rst_n = 0;
		Bps_En = 0;
		#100;
		Rst_n = 1;
		forever@(posedge Tx_En)/*ÿһʹźżִһη͹*/
			Uart_Send(Tx_Data);	
	end

/*ִһֽݵķ*/	
	task Uart_Send;
		input [7:0]Data;
		begin
			Bps_En = 1;
			Tx_Done = 0;
			$display("Uart_Send Data = %0h",Data);/*ӡ͵*/
			@(posedge Bps_Clk) #0.1 uart_tx = 0;
			@(posedge Bps_Clk) #0.1 uart_tx = Data[0];
			@(posedge Bps_Clk) #0.1 uart_tx = Data[1];
			@(posedge Bps_Clk) #0.1 uart_tx = Data[2];
			@(posedge Bps_Clk) #0.1 uart_tx = Data[3];
			@(posedge Bps_Clk) #0.1 uart_tx = Data[4];
			@(posedge Bps_Clk) #0.1 uart_tx = Data[5];
			@(posedge Bps_Clk) #0.1 uart_tx = Data[6];
			@(posedge Bps_Clk) #0.1 uart_tx = Data[7];
			@(posedge Bps_Clk) #0.1 uart_tx = 1;
			@(posedge Bps_Clk) #0.1 ;
			Tx_Done = 1;
			Bps_En = 0;
			#20 Tx_Done = 0;
		end
	endtask
	
endmodule

/*ڷͷģͲģ*/
module TxModel_Bps_Gen(
	Clk,
	Rst_n,
	Baud_Set,
	Tx_Done,
	Bps_Clk,
	Byte_En
);
	
	input Clk;		/*ϵͳʱӣĬΪ50M*/
	input Rst_n;	/*ȫָλ͵ƽλ*/
	input [2:0]Baud_Set;	/*ѡź*/
	input Tx_Done;	/*ֽڷɱ־ź*/
	input Byte_En;	/*ʹֽܵڷ͵Ĳ*/
	output reg Bps_Clk;	/*Ͳʱ*/
	
	
	parameter system_clk = 50_000_000; /*ʱƵ趨Ĭ50M*/

/*ʱƵʼɸʱƵļֵ*/		
	localparam bps9600 = system_clk/9600 - 1;
	localparam bps19200 = system_clk/19200 - 1;
	localparam bps38400 = system_clk/38400 - 1;
	localparam bps57600 = system_clk/57600 - 1;
	localparam bps115200 = system_clk/115200 - 1;
	localparam bps230400 = system_clk/230400 - 1;
	localparam bps460800 = system_clk/460800 - 1;
	localparam bps921600 = system_clk/921600 - 1;		
	
	reg [31:0]BPS_PARA;/*ʷƵļֵ*/

	always@(posedge Clk or negedge Rst_n)
	if(!Rst_n)begin
		BPS_PARA <= bps9600;/*λʱĬΪ9600bps*/
	end
	else begin
		case(Baud_Set)/*ݲʿźѡͬĲʼֵ*/
			3'd0: BPS_PARA <= bps9600;
			3'd1: BPS_PARA <= bps19200;
			3'd2: BPS_PARA <= bps38400;
			3'd3: BPS_PARA <= bps57600;
			3'd4: BPS_PARA <= bps115200;
			3'd5: BPS_PARA <= bps230400;
			3'd6: BPS_PARA <= bps460800;
			3'd7: BPS_PARA <= bps921600;			
			default: BPS_PARA <= bps9600;
		endcase
	end
	
//=========================================================
	reg[12:0]Count;
	
	reg n_state;
	localparam IDEL_1 = 1'b0,
				  SEND   = 1'b1;
				  
	reg BPS_EN;
	
/*-------ʱɿ߼--------------*/	
	always@(posedge Clk or negedge Rst_n)
	if(!Rst_n)begin
		BPS_EN <= 1'b0;
		n_state <= IDEL_1;
	end
	else begin
		case(n_state)
			IDEL_1:
				if(Byte_En)begin/*⵽ֽڷʹźţɽ̣ͬʱ뷢״̬*/
					BPS_EN <= 1'b1;
					n_state <= SEND;
				end
				else begin
					n_state <= IDEL_1;
					BPS_EN <= 1'b0;
				end
			SEND:
				if(Tx_Done == 1)begin/*ɣرղɽ̣ص״̬*/
					BPS_EN <= 1'b0;
					n_state <= IDEL_1;
				end
				else begin
					n_state <= SEND;
					BPS_EN <= 1'b1;
				end
			default:n_state <= IDEL_1;
		endcase
	end

/*-------ʱɶʱ--------------*/	
	always@(posedge Clk or negedge Rst_n)
	if(!Rst_n)
		Count <= 13'd0;	
	else if(BPS_EN == 1'b0)
		Count <= 13'd0;
	else begin
		if(Count == BPS_PARA)
			Count <= 13'd0;
		else 
			Count <= Count + 1'b1;
	end
	
/*ݽղʱ*/	
//-----------------------------------------------
	always @(posedge Clk or negedge Rst_n)
	if(!Rst_n)
		Bps_Clk <= 1'b0;
	else if(Count== 1)
		Bps_Clk <= 1'b1;
	else 
		Bps_Clk <= 1'b0;

//===================================================

endmodule
